//
//  APITwitter.m
//  EquilibrioChipmunk
//
//  Created by Javier Cala Uribe on 31/03/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "APITwitter.h"

@implementation APITwitter

@synthesize user;
@synthesize pass;
@synthesize inputInfo;
@synthesize delegate;
@synthesize callback;
@synthesize errorCallback;

-(void)getSearch:(NSString *)status delegate:(id)requestDelegate requestSelector:(SEL)requestSelector; {	
	// Define el tipo de método a utilizar GET o POST
	isPost = NO;

	self.delegate = requestDelegate;
	self.callback = requestSelector;
	
	// Cambia los espacios en blanco " " por "+" para la búsqueda
	NSString *newStr = [status stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	
	// Se defina el formato de envio a Twitter de la búsqueda
	NSString *searchUrl = [NSString stringWithFormat:@"http://search.twitter.com/search.atom?q=%@",newStr];	
	NSURL *url = [NSURL URLWithString:searchUrl];
	
	// Procesar solicitud
	[self request:url];
}

-(void)statuses_update:(NSString *)status delegate:(id)requestDelegate requestSelector:(SEL)requestSelector; {
	// Define el tipo de método a utilizar GET o POST
	isPost = YES;

	self.delegate = requestDelegate;
	self.callback = requestSelector;

	// Se define el formato de envio a Twitter de la actualización
	NSURL *url = [NSURL URLWithString:@"http://twitter.com/statuses/update.xml"];
	requestBody = [NSString stringWithFormat:@"status=%@",status];
	
	// Procesar solicitud
	[self request:url];	
}

-(void)request:(NSURL *) url {
	request = [[NSMutableURLRequest alloc] initWithURL:url];
	
	if(isPost) {
		NSLog(@"es Post");
		[request setHTTPMethod:@"POST"];
		[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
		[request setHTTPBody:[requestBody dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES]];
		[request setValue:[NSString stringWithFormat:@"%d",[requestBody length] ] forHTTPHeaderField:@"Content-Length"];
	}
	
	theConnection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	
	if (theConnection) {
		inputInfo = [[NSMutableData data] retain];
	} else {
		NSLog(@"Error en la Conexion");
	}
}

- (void)connection:(NSURLConnection *)connection didReceiveAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge {
	
	if ([challenge previousFailureCount] == 0) {
        NSURLCredential *newCredential;
        newCredential=[NSURLCredential credentialWithUser:[self user]
                                                 password:[self pass]
                                              persistence:NSURLCredentialPersistenceNone];
        [[challenge sender] useCredential:newCredential
               forAuthenticationChallenge:challenge];

    } else {
        [[challenge sender] cancelAuthenticationChallenge:challenge];
		UIAlertView* alertView = [[UIAlertView alloc] initWithTitle:@"Error API Twitter" message:@"Usuario y/o Contraseña Incorrecto"
														   delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alertView show];
		[alertView release];
    }	
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
    [inputInfo setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	NSLog([[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]);
    [inputInfo appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error{

    [connection release];
    [inputInfo release];	
	[request release];
	
    NSLog(@"Conexion Fallida! Error - %@ %@",
          [error localizedDescription],
          [[error userInfo] objectForKey:NSErrorFailingURLStringKey]);
	
	if(errorCallback) {
		[delegate performSelector:errorCallback withObject:error];
	}
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	
	if(delegate && callback) {
		if([delegate respondsToSelector:self.callback]) {
			[delegate performSelector:self.callback withObject:inputInfo];
		} else {
			NSLog(@"No hay respuesta desde delegate");
		}
	} 
	
	[connection release];
    [inputInfo release];
	[request release];
}

-(void) dealloc {
	[super dealloc];
}

@end